(function() {
    if (!window.translate) {
        /**
         * this global function is for string substitution
         * @property {string} string to translate.
         * @property {string} as much
         * return STRING
         */
        window.translate = function() {
            var html = [
            ];
            var arguments = arguments;
            var format = arguments[0];

            var objIndex = 0;
            var reg = /\%s/;
            var parts = [
            ];

            /**
             * analyze the string, extract the parts with the %s identifier.
             */
            for (var m = reg.exec(format); m; m = reg.exec(format)) {
                parts.push(format.substr(0, m[0][0] == "%" ? m.index : m.index + 1));
                parts.push("%s");
                format = format.substr(m.index + m[0].length);
            }

            parts.push(format);

            /**
             * analyze the parts, replace the %s with the given arguments.
             * beware of undefined!
             */
            for (var i = 0; i < parts.length; ++i) {
                var part = parts[i];

                if (part && part === "%s") {
                    var object = arguments[++objIndex];

                    if (object === undefined) {
                        html.push("%s");
                    } else {
                        html.push(object);
                    }
                    ;
                }
                else {
                    html.push(part);
                }
            }

            /**
             * Join the array and return as string.
             */
            return html.join('');
        }
    }
    ;
})();



qrcode_int = 0;
qrcode_count = 0;
qrcode_loading = 0;


function lg_main_showQRClose()
{
    if (qrcode_int > 0)
        clearInterval(qrcode_int);
    document.getElementById('qrcodediv').style.display = 'none';
}

function lg_main_showQRi(code, coords)
{

    qdiv = document.getElementById('qrcodediv');

    if (qdiv.parentNode != document.body) {
        document.body.appendChild(qdiv); // переместить в BODY, если надо
    }
    // qdiv.parentNode.removeChild(qdiv);

    if (qrcode_int > 0)
        clearInterval(qrcode_int);

    if (qrcode_count > 10)
    {
        document.getElementById('qrcodediv').style.display = 'none';
        return false;
    }

    if (typeof window['qrcode'] == 'undefined')
    {
        if (qrcode_loading == 0)
        {
            var script = document.createElement("script");
            script.type = "text/javascript";
            script.src = "/tim/js/qrcode/jsqrcode.js";    // use this for linked script
            document.body.appendChild(script);
            qrcode_loading = 1;
        }
        qrcode_int = window.setTimeout(lg_main_showQRi, 500, code, coords);

        qrcode_count++;
        lg_main_showQR(code, coords, 0);
    }
    else
    {
        lg_main_showQR(code, coords, 1);
    }


}
function lg_main_showQR(code, coords, ready)
{

    qrdiv = document.getElementById('qrcodediv');

    if (ready)
    {
        qrdiv.innerHTML = '<div align="center"><div id="qrcodediv_qr"></div></div>';

        if (qdiv.style.display == 'block' && qdiv.style.top == (coords.top + 25) + 'px')
        {
            lg_main_showQRClose();
            return false;
        }
        else
        {
            qrdiv.style.top = (coords.top + 25) + 'px';
            qrdiv.style.left = (coords.left + 25) + 'px';
            qrdiv.style.display = 'block';
            qrdiv.innerHTML = create_qrcode(code, 6);
        }
    }
    else
    {
        qrdiv.style.top = (coords.top + 28) + 'px';
        qrdiv.style.left = (coords.left + 28) + 'px';
        qrdiv.style.display = 'block';
        qrdiv.innerHTML = '<div align="center"><img border="0" style="margin:25px;" src="/tim/pb2.gif"></div>';
    }

}



function showallservices()
{

    if ($('#ddmenu').css('display') == 'none')
    {
        $('#ddmenu').show();

    }
    else
    {
        $('#ddmenu').hide();

    }
}


function doClear(theText) {
    if (theText.value == theText.defaultValue) {
        theText.value = ""
    }
}

function voteit(vote_table, vote_idname, vote_id, vote)
{

    $.get("/voteit." + vote_table + "." + vote_idname + "." + vote_id + "." + vote + ".html", function(data)
    {
        if (data != '')
        {

            $("#votes_" + vote_id).animate({
                opacity: 'hide'
            }, 10);

            $("#votes_" + vote_id).html(data);

            if (data > 0)
                $("#votes_" + vote_id).attr('class', 'voteplus');
            if (data == 0)
                $("#votes_" + vote_id).attr('class', 'votezero');
            if (data < 0)
                $("#votes_" + vote_id).attr('class', 'voteminus');

            $("#votes_" + vote_id).animate({
                opacity: 'show'
            }, 500);
        }
    });
}

var dialog_adr = '';

function lg_main_submitmodal()
{
    $.post(dialog_adr, $("#jjform").serialize(),
            function(data)
            {

                $("#dialog").html('<form method="post" onSubmit="lg_main_submitmodal(); return false;" action = "' + dialog_adr + '" id="jjform">' + data + '</form>');

            },
            "html"
            );
}

function lg_main_openmodal(adr, swidth, sheight)
{

    dialog_adr = adr;

    $('#dialog').dialog({
        autoOpen: false,
        title: ''
    });

    $('#dialog').dialog("option", "height", sheight);
    $('#dialog').dialog("option", "width", swidth);
    $('#dialog').dialog("option", "modal", true);

    $("#dialog").html('<div align="center"><img border="0" style="margin:50px;" src="/tim/pb2.gif"></div>');

    $('#dialog').dialog("open");


    $.post(adr, {},
            function(data)
            {
                $("#dialog").html('<form method="post" onSubmit="lg_main_submitmodal(); return false;" action = "' + adr + '" id="jjform">' + data + '</form>');
            },
            "html"
            );

}

function lg_main_closemodal()
{

    $('#dialog').animate({
        opacity: 'hide'
    }, 300);

}





function lg_main_search_sd(link)
{
    document.getElementById('search_sd_id').action = link.href;
    document.getElementById('search_sd_id').submit();
}


function lg_striptagstrim(tt)
{
    tt = tt.replace(/\r|\n/gi, " ");
    tt = tt.replace(/<br *\/?>/gi, "\n");
    tt = tt.replace(/<.*?>/gi, ' ');
    tt = tt.replace(/(^\s+)|(\s+$)/g, "");
    return tt;
}


function lg_main_maxlen(id, redirid)
{
    g = $('#' + id).val();
    maxlen = $('#' + id).attr('maxlength');

    $('#' + id + '_count').html(maxlen - g.length);

    if (g.length > (maxlen - 1))
        $('#message').focus();

}



// =-----------

var attach_count_max = 3;


function photo_attach_add(attach_block_id)
{



    attach_count = 0;
    for (i = 1; i < 10; i++)
        if (!document.getElementById(attach_block_id + '_attach_photo_' + i))
        {
            attach_count = i - 1;
            break;
        }

    if (attach_count < attach_count_max)
    {
        //attach_count
        attach_count++;
        attach_block_obj = document.getElementById(attach_block_id);
        new_attach = document.createElement("div");
        new_attach.id = attach_block_id + '_attach_' + attach_count;
        new_attach.style.margin = '0px';
        new_attach.style.padding = '0px';
        new_attach.width = '100%';
        new_attach.innerHTML = '<table width=\"100%\"><tr valign=\"top\"><td><input size="50" type=\"file\" style=\"height:23px;width:100%\" id=\"' + attach_block_id + '_attach_photo_' + attach_count + '\" name=\"' + attach_block_id + '_attach_photo_' + attach_count + '\" value=\"Файл\"></td></tr></table>';
        attach_block_obj.appendChild(new_attach);


        if (attach_count > 1)
            document.getElementById(attach_block_id + "_removeelse").style.visibility = 'visible';

        return true;

    } else {
        window.alert('Число фотографий не должно превышать ' + attach_count_max);
        return false;
    }

}

function photo_attach_remove(attach_block_id) {

    if (attach_count < 2)
        return false;

    attach_block_obj = document.getElementById(attach_block_id);
    attach_block_obj.removeChild(document.getElementById(attach_block_id + '_attach_' + attach_count));
    attach_count--;

    if (attach_count == 1)
        document.getElementById(attach_block_id + "_removeelse").style.visibility = 'hidden';

    return true;

}


// Функции комментариев
function lg_coms_deleteimg(loader, sid, sa)
{
    $.post(loader, {
        cmd: "delimg",
        id: sid,
        a: sa
    },
    function(data)
    {
        $('#cimg_' + sa).animate({
            opacity: 'hide'
        }, 500);
    },
            "html"
            );
    return false;
}

function lg_coms_edit(loader, id)
{
    $.post(loader, {
        cmd: "edit",
        id: id
    },
    function(data)
    {
        $('#chk_comment_' + id).html(data);
    },
            "html"
            );

}

function lg_coms_delete(loader, sid)
{
    $.post(loader, {
        cmd: "delcom",
        id: sid
    },
    function(data)
    {
        $('#lg_sucom_' + sid).animate({
            opacity: 'hide'
        }, 10);
    },
            "html"
            );
    return false;
}

function lg_coms_selparent(loader, qaid)
{
    if (qaid == 0)
    {
        document.getElementById('qparent').value = 0;
        ;
        document.getElementById('sqparent').innerHTML = 'Нет';

    }
    else
    {
        $.post(loader, {
            cmd: "getmess",
            id: qaid
        },
        function(data)
        {
            $('#qparent').val(qaid);
            $('#sqparent').html('<b>' + qaid + '</b> (<a href="#com' + qaid + '">Смотреть</a>) · (<a href="#postform" onClick="lg_coms_selparent(0);">Сбросить</a>)');
            $('#message').val($('#message').val() + '[quote="' + data.name + '"]' + data.message + '\n[/quote]');
        },
                "json"
                );
    }
}


function lg_coms_makeshowon(loader, sid)
{
    $.post(loader, {
        cmd: "makeshowon",
        id: sid
    },
    function(data)
    {
        if (data == 'showon')
        {
            $('#commentshowonmain_' + sid).html('<b style="color:red;">Убрать с главной</b>');
        }
        if (data == 'notshowon')
        {
            $('#commentshowonmain_' + sid).html('На главную');
        }
    },
            "html"
            );
    return false;
}


function lg_coms_spam(loader, id)
{
    alert(translate(LOCALIZATION.LG_COMS_SPAM_ALERT));
    $.post(loader, {
        cmd: "spam",
        id: id
    },
    function(data)
    {
        $('#spamlink_' + id).html('');
    },
            "html"
            );

}

function lg_main_coms_onov(id)
{
    //document.getElementById('comtable_'+id).style.display ='block';
    document.getElementById('comtable_' + id).style.filter = 'alpha(opacity=100)';
    document.getElementById('comtable_' + id).style.opacity = 1;

    //document.getElementById('comtable_'+id).style.display ='none'; this.style.background='#ffffff';
    document.getElementById('spamlink_' + id).style.display = 'block';

}


function lg_main_coms_onout(id)
{
    //document.getElementById('comtable_'+id).style.display ='block';
    document.getElementById('comtable_' + id).style.filter = 'alpha(opacity=30)';
    document.getElementById('comtable_' + id).style.opacity = 0.3;

    //document.getElementById('comtable_'+id).style.display ='none';
    document.getElementById('spamlink_' + id).style.display = 'none';

}





// Вопросы и ответы
function lg_qs_editq(loader, qid)
{
    $.post(loader, {
        cmd: "edit_q",
        id: qid
    },
    function(data)
    {
        $('#chk_question_' + qid).html(data);
    },
            "html"
            );

}



function lg_qs_edita(loader, id)
{
    $.post(loader, {
        cmd: "edit_a",
        id: id
    },
    function(data)
    {
        $('#chk_answer_' + id).html(data);
    },
            "html"
            );

}


function lg_qs_deleteimg(loader, sid, smd, sa)
{
    $.post(loader, {
        cmd: "delimg",
        id: sid,
        md: smd,
        a: sa
    },
    function(data)
    {
        $('#qimg_' + sa).animate({
            opacity: 'hide'
        }, 500);
    },
            "html"
            );
    return false;
}

function lg_qs_deletea(loader, sid)
{
    $.post(loader, {
        cmd: "delmess",
        id: sid
    },
    function(data)
    {
        $('#tr_ka_' + sid).animate({
            opacity: 'hide'
        }, 500);
    },
            "html"
            );
    return false;
}

function lg_qs_deleteq(loader, sid)
{
    $.post(loader, {
        cmd: "delq",
        id: sid
    },
    function(data)
    {
        $('#tr_kaq_' + sid).animate({
            opacity: 'hide'
        }, 500);
    },
            "html"
            );
    return false;
}

function lg_qs_setclose(loader, sid) {
    $.post(loader, {
        cmd: "setclosed",
        id: sid
    },
    function(data) {
        if (data == 'opened') {
            $('#qsopened_' + sid).html('закрыть');
            location.reload();
        }
        if (data == 'closed') {
            $('#qsopened_' + sid).html('открыть');
            location.reload();
        }
    },
            "html"
            );

    return false;
}

function lg_qs_subsc(loader, sid) {
    $.post(loader, {
        cmd: "subsc",
        id: sid
    },
    function(data) {
        if (data == 'subsced') {
            $('#qssubsc_' + sid).html('Отписаться от ответов');
        }
        if (data == 'unsubsced') {
            $('#qssubsc_' + sid).html('Подписаться на новые ответы');
        }
    },
            "html"
            );
    return false;
}


function lg_qs_setbest(loader, sid, aid) {
    $.post(loader, {
        cmd: "setbest",
        id: sid,
        aid: aid
    },
    function(data) {
        location.href = location.href;
        location.reload();
    },
            "html"
            );

    return false;
}

function lg_qs_noanswers(loader, sid) {
    $.post(loader, {
        cmd: "noanswers",
        id: sid,
    },
            function(data) {
                if (data == 'ok') {
                    alert('Спасибо за ваш голос! На этот вопрос скоро будет ответ');
                }
                if (data == 'bad') {
                    alert('Видимо вы уже голосовали');
                }

            },
            "html"
            );

    return false;
}

function lg_qs_spamq(loader, id)
{
    alert('Ваша заявка принята. Наши редакторы постараются отреагировать как можно скорее.');
    $.post(loader, {
        cmd: "spamq",
        id: id
    },
    function(data)
    {
        $('#spamlinkq_' + id).html('');
    },
            "html"
            );

}

function lg_qs_spama(loader, id)
{
    alert('Ваша заявка принята. Наши редакторы постараются отреагировать как можно скорее.');
    $.post(loader, {
        cmd: "spama",
        id: id
    },
    function(data)
    {
        $('#spamlinka_' + id).html('');
    },
            "html"
            );

}


function lg_qs_selparent(loader, qaid)
{
    if (qaid == 0)
    {
        document.getElementById('qparent').value = 0;
        ;
        document.getElementById('sqparent').innerHTML = 'Нет';

    }
    else
    {
        $.post(loader, {
            cmd: "getmess",
            id: qaid
        },
        function(data)
        {
            $('#qparent').val(qaid);
            $('#sqparent').html('<b>' + qaid + '</b> (<a href="#qsa' + qaid + '">Смотреть</a>) · (<a href="#postform" onClick="lg_qs_selparent(0,0);">Сбросить</a>)');
            $('#message').val($('#message').val() + '[quote="' + data.name + '"]' + data.message + '[/quote]');
        },
                "json"
                );
    }
}



function lg_main_qs_onov(id)
{
    //document.getElementById('comtable_'+id).style.display ='block';
    document.getElementById('qsatable_' + id).style.filter = 'alpha(opacity=100)';
    document.getElementById('qsatable_' + id).style.opacity = 1;

    //document.getElementById('qsatable_'+id).style.display ='none'; this.style.background='#ffffff';
    document.getElementById('spamlinka_' + id).style.display = 'block';

}


function lg_main_qs_onout(id)
{
    //document.getElementById('comtable_'+id).style.display ='block';
    document.getElementById('qsatable_' + id).style.filter = 'alpha(opacity=30)';
    document.getElementById('qsatable_' + id).style.opacity = 0.3;

    //document.getElementById('comtable_'+id).style.display ='none';
    document.getElementById('spamlinka_' + id).style.display = 'none';

}

function lg_qs_agreed(loader, sid, stat)
{
    var s = 0;
    $.post(loader, {
        cmd: "agreed",
        id: sid,
        stat: stat
    },
    function(data) {
        if (data == 'checked') {
            $('#qs_agreed').attr('checked', true);
            $('#qs_agreed_span').show();
            s = 1;
        }
        if (data == 'unchecked') {
            $('#qs_agreed').attr('checked', false);
            $('#qs_agreed_span').hide();
            s = 1;
        }
        if (data == 'nobestsel') {
            $('#qs_agreed').attr('checked', !stat);
            alert('Для решения необходимо выбрать лучший ответ!');
            s = 1;
        }

        if (!data || s == 0) {
            $('#qs_agreed').attr('checked', !stat)
        }
    },
            "html"
            );

    return false;
}


// Reviews functions
function lg_reviews_deleteimg(loader, sid, sa)
{
    $.post(loader, {
        cmd: "delimg",
        id: sid,
        a: sa
    },
    function(data)
    {
        $('#cimg_' + sa).animate({
            opacity: 'hide'
        }, 500);
    },
            "html"
            );
    return false;
}

function lg_reviews_edit(loader, id)
{
    $.post(loader, {
        cmd: "edit",
        id: id
    },
    function(data)
    {
        $('#chk_review_' + id).html(data);

    },
            "html"
            );

}

function lg_reviews_delete(loader, sid)
{
    $.post(loader, {
        cmd: "delreview",
        id: sid
    },
    function(data)
    {
        $('#lg_sureview_' + sid).animate({
            opacity: 'hide'
        }, 10);
    },
            "html"
            );
    return false;
}

function lg_reviews_makeshowon(loader, sid)
{
    $.post(loader, {
        cmd: "makeshowon",
        id: sid
    },
    function(data)
    {
        if (data == 'showon')
        {
            $('#reviewshowonmain_' + sid).html('<b style="color:red;">Убрать с главной</b>');
        }
        if (data == 'notshowon')
        {
            $('#reviewshowonmain_' + sid).html('На главную');
        }
    },
            "html"
            );
    return false;
}

function lg_reviews_spam(loader, id)
{
    alert('Ваша заявка принята. Наши редакторы постараются отреагировать как можно скорее.');
    $.post(loader, {
        cmd: "spam",
        id: id
    },
    function(data)
    {
        $('#spamlink_' + id).html('');
    },
            "html"
            );

}


function lg_users_contacts_add(loader, sid)
{
    $.post(loader, {
        cmd: "adduser",
        id: sid,
    },
            function(data)
            {
                if (data == 'ok')
                {
                    $('#user_' + sid).animate({
                        opacity: 'hide'
                    }, 500);
                    alert('Пользователь успешно добавлен в контакты');
                }
                else
                {
                    alert('Не удалось добавить пользователя в контакты');
                }
            },
            "html"
            );
    return false;
}

function lg_users_contacts_remove(loader, sid)
{
    $.post(loader, {
        cmd: "deluser",
        id: sid,
    },
            function(data)
            {

                $('#user_' + sid).animate({
                    opacity: 'hide'
                }, 500);
                alert('Пользователь успешно удален из списка контактов');

            },
            "html"
            );
    return false;
}

function setCheckboxes(the_form, field_name, do_check)
{
    var elts = document.forms[the_form].elements[field_name];
    var elts_cnt = (typeof (elts.length) != 'undefined')
            ? elts.length
            : 0;

    if (elts_cnt)
    {
        for (var i = 0; i < elts_cnt; i++)
        {
            elts[i].checked = do_check;
        } // end for
    }
    else
    {
        elts.checked = do_check;
    } // end if... else

    return true;
}


function lg_divcat_gencname(inid)
{

    var los = cyr2lat(document.getElementById(inid).value);

    los = los.replace(/[ ]+$/gi, "");
    los = los.replace(/ /gi, "-");

    return los;
}

function lg_divcat_stradd(add)
{
    return add;
}


function cyr2lat(str)
{

    var cyr2latChars = new Array(
            [
                'а', 'a'
            ], [
        'б', 'b'
    ], [
        'в', 'v'
    ], [
        'г', 'g'
    ],
            [
                'д', 'd'
            ], [
        'е', 'e'
    ], [
        'ё', 'yo'
    ], [
        'ж', 'zh'
    ], [
        'з', 'z'
    ],
            [
                'и', 'i'
            ], [
        'й', 'y'
    ], [
        'к', 'k'
    ], [
        'л', 'l'
    ],
            [
                'м', 'm'
            ], [
        'н', 'n'
    ], [
        'о', 'o'
    ], [
        'п', 'p'
    ], [
        'р', 'r'
    ],
            [
                'с', 's'
            ], [
        'т', 't'
    ], [
        'у', 'u'
    ], [
        'ф', 'f'
    ],
            [
                'х', 'h'
            ], [
        'ц', 'c'
    ], [
        'ч', 'ch'
    ], [
        'ш', 'sh'
    ], [
        'щ', 'shch'
    ],
            [
                'ъ', ''
            ], [
        'ы', 'y'
    ], [
        'ь', ''
    ], [
        'э', 'e'
    ], [
        'ю', 'yu'
    ], [
        'я', 'ya'
    ],
            [
                'А', 'A'
            ], [
        'Б', 'B'
    ], [
        'В', 'V'
    ], [
        'Г', 'G'
    ],
            [
                'Д', 'D'
            ], [
        'Е', 'E'
    ], [
        'Ё', 'YO'
    ], [
        'Ж', 'ZH'
    ], [
        'З', 'Z'
    ],
            [
                'И', 'I'
            ], [
        'Й', 'Y'
    ], [
        'К', 'K'
    ], [
        'Л', 'L'
    ],
            [
                'М', 'M'
            ], [
        'Н', 'N'
    ], [
        'О', 'O'
    ], [
        'П', 'P'
    ], [
        'Р', 'R'
    ],
            [
                'С', 'S'
            ], [
        'Т', 'T'
    ], [
        'У', 'U'
    ], [
        'Ф', 'F'
    ],
            [
                'Х', 'H'
            ], [
        'Ц', 'C'
    ], [
        'Ч', 'CH'
    ], [
        'Ш', 'SH'
    ], [
        'Щ', 'SHCH'
    ],
            [
                'Ъ', ''
            ], [
        'Ы', 'Y'
    ],
            [
                'Ь', ''
            ],
            [
                'Э', 'E'
            ],
            [
                'Ю', 'YU'
            ],
            [
                'Я', 'YA'
            ],
            [
                'a', 'a'
            ], [
        'b', 'b'
    ], [
        'c', 'c'
    ], [
        'd', 'd'
    ], [
        'e', 'e'
    ],
            [
                'f', 'f'
            ], [
        'g', 'g'
    ], [
        'h', 'h'
    ], [
        'i', 'i'
    ], [
        'j', 'j'
    ],
            [
                'k', 'k'
            ], [
        'l', 'l'
    ], [
        'm', 'm'
    ], [
        'n', 'n'
    ], [
        'o', 'o'
    ],
            [
                'p', 'p'
            ], [
        'q', 'q'
    ], [
        'r', 'r'
    ], [
        's', 's'
    ], [
        't', 't'
    ],
            [
                'u', 'u'
            ], [
        'v', 'v'
    ], [
        'w', 'w'
    ], [
        'x', 'x'
    ], [
        'y', 'y'
    ],
            [
                'z', 'z'
            ],
            [
                'A', 'A'
            ], [
        'B', 'B'
    ], [
        'C', 'C'
    ], [
        'D', 'D'
    ], [
        'E', 'E'
    ],
            [
                'F', 'F'
            ], [
        'G', 'G'
    ], [
        'H', 'H'
    ], [
        'I', 'I'
    ], [
        'J', 'J'
    ], [
        'K', 'K'
    ],
            [
                'L', 'L'
            ], [
        'M', 'M'
    ], [
        'N', 'N'
    ], [
        'O', 'O'
    ], [
        'P', 'P'
    ],
            [
                'Q', 'Q'
            ], [
        'R', 'R'
    ], [
        'S', 'S'
    ], [
        'T', 'T'
    ], [
        'U', 'U'
    ], [
        'V', 'V'
    ],
            [
                'W', 'W'
            ], [
        'X', 'X'
    ], [
        'Y', 'Y'
    ], [
        'Z', 'Z'
    ],
            [
                ' ', ' '
            ], [
        '0', '0'
    ], [
        '1', '1'
    ], [
        '2', '2'
    ], [
        '3', '3'
    ],
            [
                '4', '4'
            ], [
        '5', '5'
    ], [
        '6', '6'
    ], [
        '7', '7'
    ], [
        '8', '8'
    ], [
        '9', '9'
    ],
            [
                '-', '-'
            ]

            );

    var newStr = new String();

    for (var i = 0; i < str.length; i++) {

        ch = str.charAt(i);
        var newCh = '';

        for (var j = 0; j < cyr2latChars.length; j++) {
            if (ch == cyr2latChars[j][0]) {
                newCh = cyr2latChars[j][1];

            }
        }
        // Если найдено совпадение, то добавляется соответствие, если нет - пустая строка
        newStr += newCh;

    }
    // Удаляем повторяющие знаки - Именно на них заменяются пробелы.
    // Так же удаляем символы перевода строки, но это наверное уже лишнее
    //return newStr.replace(/[-]{2,}/gim, '-').replace(/\n/gim, '');
    return  newStr;
}

/*
 *
 * Copyright (c) 2010 C. F., Wong (<a href="http://cloudgen.w0ng.hk">Cloudgen Examplet Store</a>)
 * Licensed under the MIT License:
 * http://www.opensource.org/licenses/mit-license.php
 *
 */


(function($) {
    var className = "Truncator",
            re1 = /(<(?:[^>"']|'[^']*'|"[^"]*")+>)|([\s\r\n]+)|(\S)/g,
            re2 = /<\s*([^\s>]*)\s*>([\s\S](?!<\/\1>))*[\s\S]<\/\1>|<hr\s*\/?>|<br\s*\/?>|<li\s*\/?>/ig,
            re3 = /\[\[/g,
            re4 = /\]\]/g;
    function truncate(obj, t, c) {
        var truncText = [
        ],
                remain = [
                ],
                count = 0,
                noMoreText = false;
        $(t).html().replace(
                re1
                , function(s, s1, s2, s3) {
                    if (typeof s3 === "string" && s3 != "") {
                        if (!noMoreText) {
                            truncText.push(s3);
                            count++
                        }
                    } else if (typeof s2 === "string" && s2 != "") {
                        if (count >= c)
                            noMoreText = true;
                        if (!noMoreText) {
                            truncText.push(" ");
                            count++
                        }
                    } else if (typeof s1 === "string" && s1 != "") {
                        if (count >= c)
                            noMoreText = true;
                        if (count < c)
                            truncText.push(s1);
                        else
                            remain.push(s1);
                    }
                });
        re = remain.join("").replace(
                re2
                , "");
        if (re == "")
            this.disabled = true;
        return truncText.join("") + re
    }
    function Truncator(
            target, n, trail_more, trail_less, originalText, seed
            ) {
        var n = n || 60,
                trail_more = trail_more || "[[...]]",
                trail_less = trail_less || "",
                originalText = originalText || "",
                seed = seed || null;
        if (target) {
            this.init(target, n, trail_more, trail_less, originalText);
            if (
                    !$(target).data("init") ||
                    typeof $(target).data("init").length == "undefined"
                    )
                $(target).data("init", [
                ]);
            if (originalText == "")
                originalText = this.originalText;
            if (!seed)
                seed = this.seed;
            $(target)
                    .data("init")
                    .push(function(e) {
                        new Truncator(e, n, trail_more, trail_less, originalText, seed)
                                .live()
                    });
        }
    }
    Truncator.prototype.init = function(
            target, n, trail_more, trail_less, originalText, seed
            ) {
        this.className = className;
        this.seed = seed | Math.round(Math.random() * 10000);
        this.disabled = false;
        this.target = $(target)
                .data(className, this)
                .addClass(className + this.seed);
        this.showClass = className + "show" + this.seed;
        this.hideClass = className + "hide" + this.seed;
        if (originalText && originalText != "")
            this.originalText = originalText;
        else
            this.originalText = this.target.html();
        this.truncText = truncate(this, target, n);
        this.trail_more = trail_more.replace(
                re3,
                '<a href="javascript:void(0)" class="' + this.showClass + '">'
                ).replace(
                re4,
                '</a>'
                );
        this.trail_less = trail_less.replace(
                re3,
                '<a href="javascript:void(0)" class="' + this.hideClass + '">'
                ).replace(
                re4,
                '</a>'
                );
        if (this.disabled)
            this.show();
        else
            this.hide()
    };
    Truncator.prototype.show = function() {
        var r = this.originalText;
        if (!this.disabled)
            r += this.trail_less;
        this
                .target
                .html(r);
        return this
    };
    Truncator.prototype.html = function(t) {
        if (t) {
            this
                    .target
                    .html(t);
            return this
        } else
            return this
                    .target
                    .html()
    }
    Truncator.prototype.hide = function() {
        if (this.truncText.length == this.originalText.length)
            this.target.html(this.truncText);
        else
            this.target.html(this.truncText + this.trail_more);
        return this
    };
    Truncator.prototype.live = function() {
        var t = this;
        if (!this.goLive) {
            $("." + this.showClass)
                    .live("click", function() {
                        t.show();
                    });
            $("." + this.hideClass)
                    .live("click", function() {
                        t.hide();
                    });
            this.goLive = true;
        }
        return this
    };
    $.fn.trunc = function(
            n, trail_more, trail_less
            ) {
        this.each(function() {
            new Truncator(this, n, trail_more, trail_less)
                    .live()
        });
        return this
    };
})(jQuery);


